﻿using ListBoxSortFilterSearch.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ListBoxSortFilterSearch
{
    /// <summary>
    /// MainWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class MainWindow : Window
    {
        private ListCollectionView _myCollectionView;
        private Emp _emp;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void spMain_DataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            _myCollectionView = CollectionViewSource.GetDefaultView(spMain.DataContext) as ListCollectionView;
        }

        private void ListBoxHeader_OnClick(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            _myCollectionView.SortDescriptions.Clear();

            switch(button.Name)
            {
                case "btnEmpNo":
                    _myCollectionView.SortDescriptions.Add(new System.ComponentModel.SortDescription("EmpNo", System.ComponentModel.ListSortDirection.Ascending));
                    break;
                case "btnName":
                    _myCollectionView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Name", System.ComponentModel.ListSortDirection.Ascending));
                    break;
                case "btnJob":
                    _myCollectionView.SortDescriptions.Add(new System.ComponentModel.SortDescription("Job", System.ComponentModel.ListSortDirection.Ascending));
                    break;
            }
        }

        private void Move_OnClick(object sender, RoutedEventArgs e)
        {
            Button button = sender as Button;
            _myCollectionView.SortDescriptions.Clear();

            switch (button.Name)
            {
                case "btnPrev":
                    if (_myCollectionView.MoveCurrentToPrevious())
                        _emp = _myCollectionView.CurrentAddItem as Emp;
                    else
                        _myCollectionView.MoveCurrentToFirst();
                    break;
                case "btnNext":
                    if (_myCollectionView.MoveCurrentToNext())
                        _emp = _myCollectionView.CurrentAddItem as Emp;
                    else
                        _myCollectionView.MoveCurrentToLast();
                    break;
            }
        }

        private void btnManagerOnly_Click(object sender, RoutedEventArgs e)
        {
            switch (_myCollectionView.Filter)
            {
                case null: 
                    _myCollectionView.Filter = IsManager;
                    break;
                default:
                    _myCollectionView.Filter = null;
                    break;
            }
        }

        private bool IsManager(object obj)
        {
            Emp e = obj as Emp;
            return e?.Job == "Manager";
        }
    }
}
